<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version = '1.0' 
     xmlns:xsl='http://www.w3.org/1999/XSL/Transform'
     xmlns:sp="http://www.springframework.org/schema/beans"
     xmlns="http://schema.nwiresoftware.com/model" 
     xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
     >
      
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>

	<xsl:template match="/sp:beans" >
		<xsl:element name="model">
			<xsl:attribute name="xsi:schemaLocation">http://schema.nwiresoftware.com/model ../schema/nwire-model.xsd</xsl:attribute>
			<xsl:element name="resource">
				<xsl:attribute name="type">spring-beans-xml</xsl:attribute>
				<xsl:apply-templates/>
			</xsl:element>
		</xsl:element>
	</xsl:template>
	
	<xsl:template match="//sp:bean">
		<xsl:element name="component">
			<xsl:attribute name="type">spring-bean</xsl:attribute>
			<xsl:attribute name="name">
				<xsl:value-of select="./@id"/> 
			</xsl:attribute>
			<xsl:apply-templates select="./@*"/>
			<xsl:apply-templates select="./sp:property" mode="reference-search"/>
		</xsl:element>
		<xsl:apply-templates/>
	</xsl:template>

	<xsl:template match="//sp:property" mode="reference-search">
	 	<xsl:if test="./@ref">
			<xsl:element name="association">
				<xsl:attribute name="type">spring-bean-uses-spring-bean</xsl:attribute>
				<xsl:attribute name="to">
					<xsl:value-of select="./@ref"/> 
				</xsl:attribute>
			</xsl:element>
	 	</xsl:if>
	</xsl:template>
	
	<xsl:template match="@class">
		<xsl:element name="association">
			<xsl:attribute name="type">spring-bean-is-java-class</xsl:attribute>
			<xsl:attribute name="to">
				<xsl:value-of select="."/> 
			</xsl:attribute>
		</xsl:element>
	</xsl:template>
	
	<xsl:template match="@parent">
		<xsl:element name="association">
			<xsl:attribute name="type">spring-bean-extends-spring-bean</xsl:attribute>
			<xsl:attribute name="to">
				<xsl:value-of select="."/>
			</xsl:attribute>
			<xsl:attribute name="to-type">
				java-class
			</xsl:attribute>
		</xsl:element>
	</xsl:template>
	
	<xsl:template match="@abstract|@scope|@lazy-init">
		<xsl:element name="property">
			<xsl:attribute name="name">
				<xsl:value-of select="local-name()"/>
			</xsl:attribute>
			<xsl:attribute name="value">
				<xsl:value-of select="."/>
			</xsl:attribute>
		</xsl:element>
	</xsl:template>
	
	<xsl:template match="@*|node()">
		<xsl:apply-templates/>
	</xsl:template>	
	
</xsl:stylesheet>